"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerSample(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "sampleId",
        "sampleType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "gelPhase": reports_3_0_0.GelPhase,
            "method": reports_3_0_0.Method,
            "phase": reports_3_0_0.Phase,
            "preservationMethod": reports_3_0_0.PreservationMethod,
            "sampleType": reports_3_0_0.SampleType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.GelPhase": reports_3_0_0.GelPhase,
            "org.gel.models.report.avro.Method": reports_3_0_0.Method,
            "org.gel.models.report.avro.Phase": reports_3_0_0.Phase,
            "org.gel.models.report.avro.PreservationMethod": reports_3_0_0.PreservationMethod,
            "org.gel.models.report.avro.SampleType": reports_3_0_0.SampleType,
            "org.gel.models.report.avro.CancerSample": reports_3_0_0.CancerSample,
        }

    __slots__ = [
        "sampleId",
        "sampleType",
        "gelPhase",
        "grade",
        "labId",
        "method",
        "phase",
        "preservationMethod",
        "sampleDiagnosis",
        "tmn_stage_grouping",
        "tnm_stage_version",
        "tumorContent",
        "tumorPurity",
        "tumorSubType",
        "tumorType",
    ]

    def __init__(
        self,
        sampleId,
        sampleType,
        gelPhase=None,
        grade=None,
        labId=None,
        method=None,
        phase=None,
        preservationMethod=None,
        sampleDiagnosis=None,
        tmn_stage_grouping=None,
        tnm_stage_version=None,
        tumorContent=None,
        tumorPurity=None,
        tumorSubType=None,
        tumorType=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.CancerSample model.

        :param sampleId:
            Sample Id (e.g, LP00012645_5GH))
        :type sampleId: str
        :param sampleType:
            Sample Type
        :type sampleType: SampleType
        :param gelPhase:
            gelPhase (eg cruk, brc, cll, iip, main)
        :type gelPhase: None | GelPhase
        :param grade:
            Grade of tumour - a lot of records gave this
        :type grade: None | str
        :param labId:
            Lab Id (this is from the bio-repository e.g D14.25586 or another
            format based on which center)
        :type labId: None | str
        :param method:
            Method
        :type method: None | Method
        :param phase:
            Tumor Phase
        :type phase: None | Phase
        :param preservationMethod:
            Preservation method
        :type preservationMethod: None | PreservationMethod
        :param sampleDiagnosis:
            Sample Diagnosis (we need this because primary diagnosis or patient
            might be CLL, but this sample might be a different tumor?)
        :type sampleDiagnosis: None | str
        :param tmn_stage_grouping:
            TMN stage grouping
        :type tmn_stage_grouping: None | str
        :param tnm_stage_version:
            TMN version
        :type tnm_stage_version: None | str
        :param tumorContent:
            Sample TumorContent will be a string
        :type tumorContent: None | str
        :param tumorPurity:
            Sample tumorPurity
        :type tumorPurity: None | double
        :param tumorSubType:
            Tumor Subtype
        :type tumorSubType: None | str
        :param tumorType:
            Tumor Type     blood, breast, prostate, colorectal, cll, aml, renal,
            ovarian, skin, lymphNode, bone, blood, saliva
        :type tumorType: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
